<?php
/*

 $Id: workgroup.php,v 1.26 2004/02/11 22:19:27 vollmerk Exp $
 $Source: /data/cvsroot/maintain/docs/workgroup.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

/*!
	@header Workgroup Document
	Create/edit/delete Workgroups.

*/

/* Start House Keeping */

	require("../modules/config.php");

	// make sure they are supposed to be here
        if (!check_session()) { logout(); }
	
	setup_user_environment($action, $zone_id);

	$conf['script'] = "workgroup.php";

/* End House Keeping */

// process any submits that may come our way
$title = "Workgroup Information";

// need this object for doing the IP math
$ip = new IP (0);

$workgroup = new Workgroup($workgroup_id);

show_template('header');

?>
<font class="header1"><?= $title ?></font>
<?
/*!
	@function create
	@discussion creating a new workgroup
		add the inital zone
*/
if ($action === 'Create') {
	
	if (!$user->is_admin) {
		$conf['ui']->show_access_denied();
		exit();
	}

	$workgroup->check_name($name);
	
	// If no errors then go ahead and create it
	if (!$conf['error']->error_state) {
		$workgroup_id = $workgroup->create_workgroup($name,$zone_id,$default,$comment);	
		$newzone = new Zone($zone_id);
		$conf['ui']->display_confirmation("Workgroup Created", "Workgroup $name created and added to " . $newzone->name, $conf['web_path'] . "/workgroup.php?action=edit&workgroup_id=$workgroup_id");
	}

	// Uhh-ooh we've lost our mojo go man go..
	else {
		$action = 'show_create';
	} // Else error


} // Create

/*!
	@function update
	@discussion this updates the workgroup, 
		there is a little different checking
		done here
*/
elseif ( $action === 'Update' ) {

	if (!$user->is_admin) {
		$conf['ui']->show_access_denied();
		exit();
	}

	// If they changed the workgroup name...
	// which is basicly the only thing they can change now 
	if ($name != $workgroup->name) {
		$workgroup->check_name($name,$workgroup);
	}

	if ( $conf['error']->error_state ) {
		// there was an error so set the appropriate action
			$action = 'edit';
			$workgroup = new Workgroup($workgroup_id);

		$workgroup->name              = $name;
	} // if error
	
	// No error occured, let's rock
	else {
		$workgroup->update_name($name);
		$action = 'edit';
		$workgroup = new Workgroup($workgroup_id);
	} // if no error
} // update_workgroup
/*!
	@function delete
	@discussion deletes the workgroup it's self, if they don't have
		access it lays down the law.
*/
elseif ( $action == 'delete' ) {

	if ($user->is_admin || $user->has_access($workgroup->zone) >= 50 ) {
		$child = new Child('workgroup',$workgroup_id);
		
		$workgroup = new Workgroup($workgroup_id);
		
		// Go through any kiddies 
		if ($child->has_children) { 
			foreach ($child->hosts as $host) {
			
			$sql = "SELECT id FROM workgroup WHERE name LIKE '" . $conf['default_workgroup'] . "'";
			$db_results = mysql_query($sql, dbh());

			$results = mysql_fetch_row($db_results);

			$host->update_workgroup($results[0]);


			} // foreach

		} //has_children
				
		$workgroup->delete();
	}
	else {
		$conf['ui']->show_access_denied();
	}

	$action = 'show_workgroups';	
	
} // delete

/*!
	@function add_zone_workgroup
	@discussion adds the specified zone to a workgroup
*/
elseif ($action == 'add_zone_workgroup') {

	if ($user->is_admin) {
		$workgroup = new Workgroup($workgroup_id);
		$workgroup->add_zone($zone_id,$default);
		$action = 'edit';
	}

} // add_zone_workgroup

/*!
	@function delete_zone_workgroup
	@discussion removes a zone to workgroup mapping, must be full admin
*/
elseif ($action == 'delete_zone_workgroup') {

	if (!$user->is_admin) { 
		$conf['ui']->show_access_denied();
		exit();
	}

	$child = new Child('zone_workgroup',$workgroup_id,$zone_id,'count');

	if (!$child->has_children) {
		$workgroup = new Workgroup($workgroup_id);
		$zone = new Zone($zone_id);
		$workgroup->delete_zone($zone_id);
		$conf['ui']->display_confirmation("Workgroup to Zone map deleted", "You have delete the " . $workgroup->name . " to " . $zone->name . " mapping", $conf['web_path'] . "/workgroup.php?action=show_workgroup&workgroup_id=$workgroup_id");
	}
	else {
		echo "<p class=\"fatalerror\">Attempted to delete workgroup with children. You by-passed the confirm page and have done something bad</p>";
		exit();
	}

} // if delete_zone_workgroup

/*!
	@function make_default
	@discussion makes a workgroup the default for a zone,
		if they make two workgroups default it's a luck
		of the draw as to which one get's picked first
*/
elseif ($action == 'make_default') { 

	if (!$user->is_admin) {
		$conf['ui']->show_access_denied();
		exit();
	}

	$workgroup->make_default($zone_id,$default);
	$action = 'show_workgroup';

} // make_default

/**************************
	SHOW IF BLOCK
**************************/

?>
<?
if ($zone_id) {
	$sql = "SELECT zone_workgroup.workgroup AS id FROM zone_workgroup,workgroup WHERE workgroup.id = zone_workgroup.workgroup AND zone_workgroup.zone='$zone_id'";
	$field = 'workgroup.name';
}
elseif ($user->is_admin) {
	$sql = "SELECT id FROM workgroup";
	$field = 'name';
}

if (!$user->view) {
	$user->view = new View($sql);
}

if ($sort_type) {
	$user->view->initialize($sort_type,$sort_offset);
}
else {
	$user->view->initialize($field, $sort_offset);
}


if ( $action == 'edit' || $action == 'show_create' || $action == 'show_workgroup') {
	// show the range edit form
	$conf['ui']->show_workgroup($action, $workgroup);
}

elseif ( $action == 'show_workgroups' ) {
	$workgroups = $conf['ui']->get_workgroups();
	$conf['ui']->show_workgroups('', $workgroups);
}
	
elseif ( $action == 'show_workgroup_ranges' ) {
	$workgroup = new Workgroup($workgroup_id);
	$ranges    = $workgroup->get_ranges();

	$conf[ui]->show_workgroup_ranges($action, $workgroup, $ranges);
}

/*!
	@function confirm_zone_workgroup_delete
	@discussion confirms that they really want to delete this mapping,
		and that there are no kiddies they'd be taking out
*/
elseif ($action == 'confirm_zone_workgroup_delete') { 

	if (!$user->is_admin) {
		$conf['ui']->show_access_denied();
		exit();
	}

	$child = new Child('zone_workgroup',$workgroup_id,$zone_id);
	if ($child->has_children) {
		$conf['ui']->display_confirmation("<font class=\"fatalerror\">Fatal Error, $child->total child objects found</font>","Please remove the below children before deleting this Zone to Workgroup mapping", $conf['web_path'] . "/index.php");
		$child->show_children();
	}
	else {
		$conf['ui']->show_confirm($conf['web_path'] . "/workgroup.php?action=delete_zone_workgroup&workgroup_id=$workgroup_id&zone_id=$zone_id","Are you sure you want to delete this Zone to Range mapping");
	}

} // confirm_zone_workgroup_delete

elseif ( $action == 'confirm_delete' || $action == 'Delete') {
	// show the confirm delete
	$workgroup = new Workgroup($workgroup_id);

	$name	= $workgroup->name;

	// For the love of god man think of the children
	$child	= new Child('workgroup',$workgroup_id,0,0,'count');
	if (!$child->has_children) { 
		$conf['ui']->show_confirm($conf['web_path'] . "/workgroup.php?action=delete&workgroup_id=$workgroup_id","Are you sure you want to delete this workgroup? ");
	}
	// Uhh ooh we've found the kiddies!
	else {
		$text = "<p class=\"error\">Error: Child Objects Found</p><p>$child->total child objects found for $name workgroup. If you delete this workgroup, all child objects will be given the default workgroup</p>"; 
		$conf['ui']->show_confirm($conf['web_path'] . "/workgroup.php?action=delete&workgroup_id=$workgroup_id", $text);
	} // if we've found kids

} // delete


show_template('footer'); 

?>
