<?php

/*

 $Id: error.php,v 1.11 2004/02/03 01:06:16 vollmerk Exp $
 $Source: /data/cvsroot/maintain/modules/class/error.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

 
/*
 The base error class that will be used for all of the error processing
   when doing form validation, etc. When checking use
if ($conf['error']->error_state) { } to see if ANY errors have occured. 
use if ($conf['error']->get_stats($name) { } to see if a specific error has occured.

if you want to make sure no errors occured (for updating) use the following

	if (!($conf['error']->error_state) ) {  } 



*/

class Error {
	var $status;
	var $message;
	var $error_state;

	function Error () {
		$this->status      = array();
		$this->message     = array();
		$this->error_state = false;
	} // Error

	//adds a error message with a specified name and sets the error state to true
	function add_error($name, $msg) {
		//set the error state to true and set the stats to true..
		$this->error_state = true;
		$this->status[$name] = true;

		//mojo that allows us to have more than one error occur in the same field
		if (!$this->message[$name]) { $this->message[$name] = "<br />" .$msg; }
		elseif ($this->message[$name]) { $this->message[$name] .= "<br />\n " . $msg; }

	}

	//gets the status of a single error name
	function get_status($name) {
		return $this->status[$name];
	} 

	//grabs the specified message
	function get_message($name) {
		return $this->message[$name];
	}

	/*
		@function show_message
		@discussion shows the message, if not found, returns false
	*/
	function show_message ($name) {
		
		if (!$msg = $this->message[$name]) { return false; }
		echo "&nbsp; <font class=\"error\">$msg</font>";
	} // show_message


	//does the get_status and if true then shows the message
	function show_error($name) {
	
		$status = $this->status[$name];
		if ($status) { 
			return "<font class=\"error\">" . $this->get_message($name) . "</font>"; 
		}

		return false;

	} //show_error

	/*!
		@function show_all_errors
		@discussion Displays all the errors that have occured
	*/
	function show_all_errors() {
		
		$status = $this->status;

		foreach ($status as $key => $error) {
			echo "<br /><font class=\"error\">Error ( $key ):" . $this->get_message($key) . "</font><br />";
		}

	} // show_all_errors

} // class Error

?>
